freeslot(
"S_INFERNOCOP_BURNINGSPIRITOFJUSTICE",
"MT_INFERNOCOP_BURNINGSPIRITOFJUSTICE",
"S_INFERNOCOP_EXPLOSIONOFJUSTICE1",
"S_INFERNOCOP_EXPLOSIONOFJUSTICE2",
"S_INFERNOCOP_EXPLOSIONOFJUSTICE3",
"S_INFERNOCOP_EXPLOSIONOFJUSTICE4",
"S_INFERNOCOP_EXPLOSIONOFJUSTICESMALL",
"MT_INFERNOCOP_EXPLOSIONOFJUSTICE",
"MT_INFERNOCOP_BULLET",
"S_INFERNOCOP_BULLET",
"SPR_ICOP",
"sfx_icboms",
"sfx_icbom1",
"sfx_icbom2",
"sfx_icbom3",
"sfx_icbom4",
"sfx_icbom5",
"sfx_icbom6",
"sfx_icric1",
"sfx_icric2",
"sfx_icgun1",
"sfx_icgun2",
"sfx_icyl1",
"sfx_icyl2",
"sfx_icyl3",
"sfx_icyl4",
"sfx_icyl5",
"sfx_icyl6",
"sfx_icyl7",
"sfx_icyl8",
"sfx_icyl9",
"sfx_icyl10",
"sfx_icyl11",
"sfx_jstic1",
"sfx_stgjal",
"sfx_icmsht",
"SKINCOLOR_JUSTICE",
"SPR_DNEX",
"SPR_ICXP",
"SPR_ICBL",
"SPR_CCOP",
"MT_INFERNOCOP_CARPART",
"SPR2_MECH",
"SPR2_MECC",
"SPR2_OJST",
"SPR2_OJSP",
"SPR2_OJCH",
"S_MECHACOP_RISE"
)

states[S_MECHACOP_RISE] = {SPR_PLAY, SPR2_STND|FF_FULLBRIGHT, 20, nil, 0, 0, S_PLAY_STND}

skincolors[SKINCOLOR_JUSTICE] = {
	name = "JUSTICEINFERNO",
	ramp = {160,160,160,161,161,161,162,162,162,163,163,163,172,197,197,197},
	invcolor = SKINCOLOR_EMERALD,
	invshade = 1,
	chatcolor = V_PURPLEMAP,
	accessible = true
}

mobjinfo[MT_INFERNOCOP_BULLET] = {
	spawnstate = S_INFERNOCOP_BULLET,
	deathstate = S_SMOKE1,
	speed = 66*FRACUNIT,
	radius = 4*FRACUNIT,
	height = 4*FRACUNIT,
	flags = MF_MISSILE|MF_NOGRAVITY|MF_NOCLIPTHING
}

states[S_INFERNOCOP_BULLET] = {SPR_ICBL, A, -1, nil, 0, 0, S_NULL}



//temp since i assume gunslinger auto resizes to fit the player scale
local function HighResBullets(mo)
	if (mo.oldscale) then return end
	mo.oldscale = mo.scale
	mo.scale = $1/5
	//P_SetScale(mo, mo.scale/5)
	mo.radius = 4*mo.oldscale
	mo.height = 4*mo.oldscale
end
addHook("MobjThinker", HighResBullets, MT_INFERNOCOP_BULLET)



//pchooooooooooooo
local function BulletSpawn(mo)
	if not (mo.valid) then return end
	
	local oldScale = mo.scale
	
	if (mo.target) then
		S_StartSound(mo.target, sfx_icgun1+P_RandomRange(0,1))
	else
		S_StartSound(mo, sfx_icgun1+P_RandomRange(0,1))
	end
	
	mo.scale = $1/5
	mo.radius = 8*oldScale
	mo.height = 8*oldScale
	mo.flags = $1 & ~MF_NOCLIPTHING
end
addHook("MobjSpawn", BulletSpawn, MT_INFERNOCOP_BULLET)



mobjinfo[MT_INFERNOCOP_BURNINGSPIRITOFJUSTICE] = {
	spawnstate = S_INFERNOCOP_BURNINGSPIRITOFJUSTICE,
	//flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIP,
	MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY,
	dispoffset = -1
}

mobjinfo[MT_INFERNOCOP_CARPART] = {
	spawnstate = S_INVISIBLE,
	//flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIP,
	MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY,
	dispoffset = -2
}

mobjinfo[MT_INFERNOCOP_EXPLOSIONOFJUSTICE] = {
	spawnstate = S_INFERNOCOP_EXPLOSIONOFJUSTICE1,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIP,
	deathsound = sfx_icboms,
	dispoffset = 1
}

states[S_INFERNOCOP_EXPLOSIONOFJUSTICE1] = {SPR_RCKT, B|FF_ANIMATE|FF_FULLBRIGHT, 12, nil, 2, 3, S_INVISIBLE}

states[S_INFERNOCOP_EXPLOSIONOFJUSTICE2] = {SPR_DNEX, A|FF_ANIMATE|FF_FULLBRIGHT, 21, nil, 20, 1, S_INVISIBLE}

states[S_INFERNOCOP_EXPLOSIONOFJUSTICE3] = {SPR_ICXP, A|FF_ANIMATE|FF_FULLBRIGHT, 14, nil, 13, 1, S_INVISIBLE}

states[S_INFERNOCOP_EXPLOSIONOFJUSTICE4] = {SPR_ICXP, O|FF_ANIMATE|FF_FULLBRIGHT, 18, nil, 17, 1, S_INVISIBLE}

states[S_INFERNOCOP_EXPLOSIONOFJUSTICESMALL] = {SPR_RCKT, B|FF_ANIMATE|FF_FULLBRIGHT, 12, nil, 2, 3, S_INVISIBLE}



//MARK A STARPOST WITH THE BLAZE OF JUSTICE IF YOU REACH IT FIRST
local function StarpostJustice(mo, pmo)
	if not (mo.state == S_STARPOST_IDLE) then return end
	
	if not (pmo.skin == "infernocop")
	and not (pmo.skin == "mechacop") then return end
	
	P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height-(25*mo.scale)), MT_INFERNOCOP_EXPLOSIONOFJUSTICE)
	S_StartSound(mo, sfx_icboms)
	local flame = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height-(25*mo.scale)), MT_INFERNOCOP_BURNINGSPIRITOFJUSTICE)
	flame.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIP|MF_SCENERY
	flame.state = S_FLAME
	
	if (pmo.skin == "mechacop") then
		flame.color = SKINCOLOR_BLUE
		flame.colorized = true
	end
end
addHook("TouchSpecial", StarpostJustice, MT_STARPOST)



local function BulletImmunity(pmo, mis)

	if not (pmo.skin == "infernocop")
	or (pmo.flags & MF_MISSILE) then return end
	
	if not (mis.flags & MF_MISSILE)
	or (mis.flags & MF_PAIN)
	or (mis.target == pmo) then return end
	
	//height checks stolen from touchspecial
	if (mis.momz < 0)
		if (mis.z + mis.momz > pmo.z + pmo.height)
			return
		end
	elseif (mis.z > pmo.z + pmo.height)
		return
	end
	
	if (mis.momz > 0)
		if (mis.z + mis.height + mis.momz < pmo.z)
			return
		end
	elseif (mis.z + mis.height < pmo.z)
		return
	end
	
	S_StartSound(pmo, sfx_icric1+P_RandomRange(0, 1))
	
	mis.angle = $1-ANGLE_180
	mis.momx = -$1*2
	mis.momy = -$1*2
	mis.momz = -$1*2
	mis.target = pmo

	return false
end
addHook("MobjCollide", BulletImmunity, MT_PLAYER)



local function SpawnExplosion(mo, range)
	//explosion stuff
	
	if not (range) then
		range = 2
	end
	
	local boom = P_SpawnMobj(mo.x, mo.y, mo.z, MT_INFERNOCOP_EXPLOSIONOFJUSTICE)
	boom.scale = mo.scale
	boom.fuse = 3*TICRATE
	if (mo.eflags & MFE_VERTICALFLIP) then
		boom.eflags = mo.eflags
		P_TeleportMove(boom, mo.x, mo.y, (mo.z+mo.height)-boom.height)
	end
	
	boom.state = S_INFERNOCOP_EXPLOSIONOFJUSTICE2+P_RandomRange(0,range)
	S_StartSound(boom, sfx_icbom1+P_RandomRange(0,5))
	
	return boom
end



local function JusticeLaunch(player)

	if (player.weapondelay) then return end
	
	if (player.powers[pw_nocontrol])
	or (player.powers[pw_carry]) then
		return
	end

	if (player.cmd.buttons & BT_CUSTOM1)
	or (player.ichead)
	and (player.weapondelay) then
		local oldHeight = player.mo.height
		player.pflags = $1|PF_SPINNING
		player.mo.target = $1
		
		player.ichead = true
		
		if not (player.iccustomheld) then
		
			player.pflags = $1|PF_JUMPED|PF_NOJUMPDAMAGE
			player.weapondelay = TICRATE/2
			local boom = SpawnExplosion(player.mo, 1)
			//JUSTICE!
			if (player.mo.skin == "overjustice")
			and not (P_RandomRange(0, 10)) then
				S_StartSound(player.mo, sfx_jstic1)
			end
			
			local heightLoss = (oldHeight-P_GetPlayerSpinHeight(player))
			
			//no boost for our robot
			if not (player.mo.skin == "mechacop") then
				//cut momentum in half when needed
				if (player.pflags & (PF_JUMPED|PF_STARTJUMP))
				and (P_MobjFlip(player.mo)*player.mo.momz > 0)
					player.mo.momz = $1>>1
					player.pflags = $1 & ~PF_STARTJUMP
				end

				local zMom = 6*FRACUNIT+(player.speed/7)
				
				local relative = false
				
				if (P_MobjFlip(player.mo)*player.mo.momz > 0) then
					relative = true
				end
				
				local xMomMod = player.mo.momx/6
				local yMomMod = player.mo.momy/6
				
				//super boost
				if (player.powers[pw_super]) then
					xMomMod = $1*2
					yMomMod = $1*2
					zMom = ($1/3)*4
				end
				
				player.mo.momx = $1+xMomMod
				player.mo.momy = $1+yMomMod
				
				P_SetObjectMomZ(player.mo, zMom, relative)
			else
				boom.color = SKINCOLOR_BLUE
				boom.colorized = true
			end

			//P_TeleportMove(player.mo, player.mo.x, player.mo.y, player.mo.z+(heightLoss*P_MobjFlip(player.mo)))
			player.mo.z = $1 + (heightLoss*P_MobjFlip(player.mo))
		end

		player.pflags = $1|PF_JUMPSTASIS
		player.iccustomheld = true
	else
	
		//only revert back on the floor
		//and when you wont be crushed
		if (P_IsObjectOnGround(player.mo))
		and (P_GetPlayerHeight(player) < R_PointToDist2(player.mo.floorz, 0, player.mo.ceilingz, 0))
			if (player.iccustomheld) then
				player.weapondelay = TICRATE/3
				player.pflags = $1 & ~PF_SPINNING
				//reset roll angle before changing the sprite
				player.mo.rollangle = 0
				local boom = SpawnExplosion(player.mo, 1)
				
				if (player.mo.skin == "mechacop") then
					boom.color = SKINCOLOR_BLUE
					boom.colorized = true
				end
				
				player.mo.state = S_PLAY_STND
				player.ichead = nil
			end
			
			player.iccustomheld = false
		end
	end
end



local function JusticeIsOver(player)
	if (player.powers[pw_super] == 1) then
		local boom = SpawnExplosion(player.mo)
		boom.scale = player.mo.scale*3
		
		local heightMod = -boom.height/2
		
		if (P_MobjFlip(player.mo) == -1) then
			heightMod = player.mo.height-$1
		end
		
		P_TeleportMove(boom, boom.x, boom.y, boom.z-heightMod)
		player.mo.state = S_PLAY_STND
	end
end



//only shoot forwards above a certain speed
local function NewGun(player)
	if not (player.mo.momz)
	and not (player.weapondelay)
	and not (player.ichead) then
	//(canstand)
	
		local bulletHeight = (player.mo.height/3)*3
		local bullet
		
		local fireDelay = TICRATE/2
		
		if (player.mo.skin == "mechacop") then
			fireDelay = TICRATE/3
		end
		
		if (player.mo.eflags & MFE_VERTICALFLIP) then
			bulletHeight = player.mo.height-$1
		end
	
		if (player.speed > FixedMul(10<<FRACBITS, player.mo.scale))
		and (player.mo.skin == "mechacop")
			if (player.cmd.buttons & BT_SPIN)
			and not (player.pflags & PF_SPINDOWN) then
				bullet = P_SpawnPointMissile(player.mo, player.mo.x + P_ReturnThrustX(nil, player.mo.angle, FRACUNIT), player.mo.y + P_ReturnThrustY(nil, player.mo.angle, FRACUNIT), player.mo.z+bulletHeight, player.revitem, player.mo.x, player.mo.y, player.mo.z+bulletHeight)
				if (bullet)
					bullet.tracer = player.mo
				end
				player.pflags = $1|PF_SPINDOWN
				player.weapondelay = fireDelay
			end
			return
		end
		
		//else
		local lockon = P_LookForEnemies(player, false, true)
		if (lockon)
		
			if (player == consoleplayer) // Only display it on your own view.
				local visual = P_SpawnMobj(lockon.x, lockon.y, lockon.z, MT_LOCKON) // positioning, flip handled in P_SceneryThinker
				visual.sprite = SPR_ICBL
				visual.frame = B
				visual.target = lockon
				visual.fuse = 1
			end
		end
		
		if (player.cmd.buttons & BT_SPIN)
		and not (player.pflags & PF_SPINDOWN) then

			player.mo.state = S_PLAY_FIRE
			
			if (lockon)
				
				//face towards the target
				local newAngle = R_PointToAngle2(player.mo.x, player.mo.y, lockon.x, lockon.y)
				if (newAngle > (player.mo.angle + (ANG1*7)))
					player.twodcharang = ANGLE_90
				elseif (newAngle < (player.mo.angle - (ANG1*7)))
					player.twodcharang = -ANGLE_90
				end
				player.mo.angle = newAngle
				
				bullet = P_SpawnPointMissile(player.mo, lockon.x, lockon.y, lockon.z+(2*(lockon.height/3)), player.revitem, player.mo.x, player.mo.y, player.mo.z+bulletHeight)
				
				if (bullet) then
					bullet.tracer = player.mo
				end
			else
			
				bullet = P_SpawnPointMissile(player.mo, player.mo.x + P_ReturnThrustX(nil, player.mo.angle, FRACUNIT), player.mo.y + P_ReturnThrustY(nil, player.mo.angle, FRACUNIT), player.mo.z+bulletHeight, player.revitem, player.mo.x, player.mo.y, player.mo.z+bulletHeight)
				if (bullet)
					bullet.tracer = player.mo
				end
			end
			player.drawangle = player.mo.angle+player.twodcharang

			player.pflags = $1|PF_SPINDOWN
			player.weapondelay = fireDelay
		end
	end
end



local function SpinningFlamesOfJustice(player)
	local flip = 0
	
	//prevent head from disappearing when in car form
	if not (player.powers[pw_sneakers])
		
		if (player.pflags & PF_SPINNING)
		or (player.ichead)
		or (player.mo.sprite2 == SPR2_SPIN) then
		
			player.mo.sprite2 = SPR2_SPIN
			
			player.mo.rollangle = $1+(player.speed*512)
			if (player.mo.eflags & MFE_VERTICALFLIP) then
				flip = player.mo.height
			end
		else
			player.mo.rollangle = 0
			flip = ((63)*player.mo.scale)
			if (player.mo.eflags & MFE_VERTICALFLIP) then
				flip = player.mo.height-$1
			end
		end
	end
	
	
	if (player.mo.justiceitem)
	and (player.mo.justiceitem.valid)
		if (player.powers[pw_sneakers]) then
			player.mo.justiceitem.sprite = SPR_CCOP
			player.mo.justiceitem.scale = (player.mo.scale/3)
			flip = 0
		else
			local flameScale = 4
			player.mo.justiceitem.sprite = SPR_ICOP
			
			if (player.mo.skin == "mechacop")
				if not (player.ichead) then
					if (player.mo.eflags & MFE_VERTICALFLIP) then
						flip = player.mo.height-56*player.mo.scale
					else
						flip = 56*player.mo.scale
					end
				end
				flameScale = 3
			end
			player.mo.justiceitem.scale = player.mo.scale/flameScale
		end
		P_TeleportMove(player.mo.justiceitem, player.mo.x, player.mo.y, player.mo.z+flip)
	end
end



local function TwoDirectionChar(player)
	if not (player.mo)
	or (player.ichead)
	or (player.mo.flags2 & MF2_TWOD) then
		return
	end
	
	local ang
	
	if (player.cmd.sidemove) then
		ang = ANGLE_90
		if (player.cmd.sidemove > 0) then
			ang = -$1
		end
	else

		if not (player.twodcharang) then
			player.twodcharang = -ANGLE_90
		end
		ang = player.twodcharang
	end
	
	player.drawangle = player.mo.angle+ang
	player.twodcharang = ang
end


//bustable breaking for mechacop
local function BustableDetect(player)
	local rover
	
	if (player.mo.momz > 0) then
		rover = player.mo.ceilingrover
	else
		rover = player.mo.floorrover
	end
	
	if not (rover)
	or not (rover.flags & FF_EXISTS)
	or not (rover.flags & FF_BUSTUP) then
		return
	end
	
	if (P_MobjFlip(player.mo)*(player.mo.z+player.mo.height) > (rover.bottomheight+1))
	and (P_MobjFlip(player.mo)*(player.mo.z+player.mo.momz) < (rover.topheight+1))
		EV_CrumbleChain(rover)
		return true
	end
end



local function BustLineCollide(mo, line)

	if not (mo.skin == "mechacop") then
		return
	end
	
	
	local sect = {line.frontsector, line.backsector}
	local doStop

	for i = 1,table.maxn(sect),1
		for rover in sect[i].ffloors()
		
			if not (rover.flags & FF_EXISTS)
			or not (rover.flags & FF_BUSTUP) then
				continue
			end
			
			if (P_MobjFlip(mo)*(mo.z+mo.height) > (rover.bottomheight))
			and (P_MobjFlip(mo)*(mo.z+mo.momz) < (rover.topheight))
				EV_CrumbleChain(sect[i], rover)
				doStop = false
			end
		end
	end

	return doStop
end
addHook("MobjLineCollide", BustLineCollide, MT_PLAYER)



local function MechaJump(player)

	if not P_IsObjectOnGround(player.mo) then
		BustableDetect(player)
	end

	if (player.ichead)
	or (player.pflags & PF_JUMPSTASIS)
	or (P_PlayerInPain(player)) then return end

	local DORISE

	if (player.cmd.buttons & BT_JUMP)
	and (player.glidetime <= 4)
	and not (player.mo.state == S_MECHACOP_RISE) then
		P_DoJump(player)
		player.glidetime = $1+1
		
		if (player.powers[pw_carry])
		or (player.pflags & PF_SLIDING) then
			player.jumpfactor = FRACUNIT/2
			P_DoJump(player, false)
			player.jumpfactor = 0
		end
		
		player.mo.state = S_MECHACOP_RISE
	end
	
	if (player.mo.state == S_MECHACOP_RISE)
	or (DORISE)
		if not (player.powers[pw_sneakers]) then
			player.mo.sprite2 = SPR2_STND
			player.mo.frame = A|FF_FULLBRIGHT
		else
			player.mo.sprite2 = SPR2_DASH
			player.mo.frame = A
		end
	
		player.pflags = $1|PF_JUMPED|PF_NOJUMPDAMAGE
		
		if not (player.mo.tics % 3)
		and (player.mo.tics) then
			local boost = FRACUNIT+(FRACUNIT/2)
			local relative = true
			
			if (player.mo.tics == 15) then
				boost = 2*FRACUNIT
			end
			
			//launch boost
			if (P_IsObjectOnGround(player.mo))
			//or (player.powers[pw_super])
			//and (player.glidetime == 1) then
				boost = $1*3
			elseif ((player.mo.momz*P_MobjFlip(player.mo)) < 0)
				//cancel momentum if falling slow enough
				if ((player.mo.momz*P_MobjFlip(player.mo)) > -20*FRACUNIT)
					relative = false
				else //otherwise add a decent decrease to the speed
					player.mo.momz = $1 + ((15*player.mo.scale)*P_MobjFlip(player.mo))
				end
			end
			
			if (player.powers[pw_super])
			and not (boost > 2*FRACUNIT) then
				boost = $1*2
			end
			
			P_SetObjectMomZ(player.mo, (boost), relative)
			
			local bullet = P_SpawnPlayerMissile(player.mo, MT_INFERNOCOP_BULLET)
			if (bullet)
				bullet.rollangle = -ANGLE_90
				
				bullet.momx = player.mo.momx
				bullet.momy = player.mo.momy
				
				if (player.mo.eflags & MFE_VERTICALFLIP) then
					bullet.eflags = $1|MFE_VERTICALFLIP
				end
				
				P_SetObjectMomZ(bullet, -30*FRACUNIT, false)
			end
		end
	end
end



//inputs, prethinkframe
local function PreThink()
	for player in players.iterate do
		if not (player.mo)
		or not (player.mo.health)
		or not (player.mo.skin == "infernocop")
		and not (player.mo.skin == "overjustice")
		and not (player.mo.skin == "mechacop") then continue end
		
		
		if (player.mo.skin == "infernocop")
		or (player.mo.skin == "overjustice") then
			JusticeLaunch(player)
			NewGun(player)
		elseif (player.mo.skin == "mechacop") then
			JusticeLaunch(player)
			NewGun(player)
			MechaJump(player)
		end
	end
end
addHook("PreThinkFrame", PreThink)



//in prethinkframe to go after twodchars
local function BurningSpirit(player)

	if (player.mo.skin == "overjustice") then
		if (player.mo.justiceitem)
		and (player.mo.justiceitem.valid) then
			P_RemoveMobj(player.mo.justiceitem)
		end
	else
	
		if not (player.mo.justiceitem)
		or not (player.mo.justiceitem.valid) then
			if not (player.mo.health) then
				return
			end

			player.mo.justiceitem = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height, MT_INFERNOCOP_BURNINGSPIRITOFJUSTICE)
			player.mo.justiceitem.color = SKINCOLOR_BLUE
			player.mo.justiceitem.target = player.mo
		end
		
		if (player.mo.justiceitem.valid) then
		
			local flameScale = 4
			
			player.mo.justiceitem.angle = player.drawangle
			
			if (player.mo.skin == "mechacop") then
				flameScale = 1
				if not (player.powers[pw_sneakers]) then
					player.mo.justiceitem.angle = $1+ANGLE_180
				end
				player.mo.justiceitem.colorized = true
			else
				player.mo.justiceitem.colorized = false
			end
			
			player.mo.justiceitem.scale = player.mo.scale/flameScale
			player.mo.justiceitem.eflags = player.mo.eflags
			
			if (player.mo.flags2 & MF2_DONTDRAW) then
				player.mo.justiceitem.flags2 = $1|MF2_DONTDRAW
			else
				player.mo.justiceitem.flags2 = $1 & ~MF2_DONTDRAW
			end
		end
	end
	
	if not (player.mo.iccar)
	or not (player.mo.iccar.valid) then
		player.mo.iccar = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_INFERNOCOP_CARPART)
		player.mo.iccar.skin = player.mo.skin
	end
	
	//car visuals
	if (player.mo.iccar.valid)
		if (player.powers[pw_sneakers]) then
		
			if (player.mo.flags2 & MF2_DONTDRAW) then
				player.mo.iccar.flags2 = $1|MF2_DONTDRAW
			else
				player.mo.iccar.flags2 = $1 & ~MF2_DONTDRAW
			end
	
			player.mo.iccar.scale = (player.mo.scale)
			player.mo.iccar.eflags = player.mo.eflags
			player.mo.iccar.angle = player.drawangle
			player.mo.iccar.state = S_PLAY_DASH
			player.mo.iccar.angle = player.drawangle
			
			//set the car to followmobj so it gets a trail too
			player.followmobj = player.mo.iccar
			P_TeleportMove(player.mo.iccar, player.mo.x, player.mo.y, player.mo.z)
		else
			player.mo.iccar.state = S_INVISIBLE
		end
	end
end



local function InfernoCarMode(player)
	if (player.powers[pw_sneakers]) then
		player.mo.sprite2 = SPR2_MLEE
		player.panim = PA_ABILITY2
		//car visuals done in burningspirit
		
		if (player.speed > 40*player.mo.scale)
		and (P_IsObjectOnGround(player.mo))
		and (player.mo.skin == "infernocop")
			if not (leveltime % 2) then
				P_ElementalFire(player)
			end
		end
	end
end



local function JusticeColors(player)
	//already flashing
	if (player.powers[pw_super]) then return end

	if (player.mo) then
		player.mo.color = (skins["overjustice"].supercolor + abs( ( (leveltime >> 1) % 9) - 4))
	end
end



//quick and easy super tints
local function GlitterMode(player)

	if (player.powers[pw_super])
	or (player.powers[pw_carry] == CR_NIGHTSMODE) then
		
		if not (player.mo.skin == "overjustice")
			player.mo.color = SKINCOLOR_GOLD
		end
		
		if (player.mo.iccar) then
			player.mo.iccar.color = player.mo.color
			player.mo.iccar.colorized = true
		end
		
		//start super music
		/*if not (player.mo.icglitter) then
			P_PlayJingleMusic(consoleplayer, "POLIZEI", 0, true, JT_SUPER)
		end*/
		
		player.mo.colorized = true
		player.mo.icglitter = true
		
		if (player.mo.justiceitem) then
			player.mo.justiceitem.scale = $1*2
		end
	elseif (player.mo.icglitter)
	
		if (player.mo.iccar) then
			player.mo.iccar.colorized = false
		end
		
		player.mo.colorized = false
		player.mo.icglitter = false
	end
end



local function PostThink()

	for player in players.iterate do

		if not (player.mo) then continue end
		
		if not (player.mo.skin == "infernocop")
		and not (player.mo.skin == "mechacop")
		and not (player.mo.skin == "overjustice") then
		
			//NO MORE GLITTER
			if (player.mo.icglitter) then
				/*if (player.powers[pw_super]) then
					P_PlayJingle(player, JT_SUPER)
				end*/
				
				player.mo.icglitter = false
				player.mo.colorized = false
			end
			continue
		end
		TwoDirectionChar(player)
		BurningSpirit(player)
		SpinningFlamesOfJustice(player)
		
		if (player.mo.skin == "overjustice") then
			JusticeColors(player)
		end
		
		GlitterMode(player)
		InfernoCarMode(player)
	end
end
addHook("PostThinkFrame", PostThink)



local function InfernoThinkFrame()
	for player in players.iterate
	
		if not (player.mo)
		or not (player.mo.valid) then continue end
		
		if not (player.mo.skin == "infernocop")
		and not (player.mo.skin == "mechacop")
		and not (player.mo.skin == "overjustice") then
			if (player.mo.justiceitem)
			and (player.mo.justiceitem.valid) then
				P_RemoveMobj(player.mo.justiceitem)
				player.mo.justiceitem = nil
			end
			
			if (player.mo.iccar)
			and (player.mo.iccar.valid) then
				P_RemoveMobj(player.mo.iccar)
				player.mo.iccar = nil
			end
			continue
		end
		
		//super transformation override
		JusticeIsOver(player)
		SpinningFlamesOfJustice(player)
		
		//fire movement, do last
		BurningSpirit(player)
	end
end
addHook("ThinkFrame", InfernoThinkFrame)



local function RemovalOfJustice(player)
	if (player.mo)
		if (player.mo.justiceitem)
		and (player.mo.justiceitem.valid) then
			P_RemoveMobj(player.mo.justiceitem)
		end
		
		if (player.mo.iccar)
		and (player.mo.iccar.valid) then
			P_RemoveMobj(player.mo.iccar)
		end
	end
end

addHook("PlayerQuit", RemovalOfJustice)



local function CarCrashInSlowMotion(player, mo)
	if not (player.mo.skin == "infernocop")
	and not (player.mo.skin == "mechacop")
	and not (player.mo.skin == "overjustice") then return end
	
	//no damage from mecha head
	if (player.mo.skin == "mechacop")
	and (player.pflags & PF_SPINNING) then
		return false
	end
	
	if not (player.powers[pw_sneakers]) then return end
	
	//metal sonic exception
	if (mo.type == MT_METALSONIC_BATTLE)
	and not (mo.flags & MF_SHOOTABLE) then
		return true
	end

	//monitors r dum
	if (mo.flags & MF_MONITOR) then
		if (P_MobjFlip(player.mo)*(player.mo.z - (mo.z)) > -(2*player.mo.scale))
		and (P_MobjFlip(player.mo)*(player.mo.z - (mo.z)) < mo.height+(2*player.mo.scale))
			P_KillMobj(mo, player.mo, player.mo)
		end
	else
		//Damage the enemy this way instead so we don't bounce
		P_DamageMobj(mo, player.mo, player.mo, 1)
	end
		
	//Single frame invincibility
	//So you don't get hurt whilst the enemy is still "alive"
	if not (player.powers[pw_flashing]) then
		player.powers[pw_flashing] = 1
	end
	
	return false
end
addHook("PlayerCanDamage", CarCrashInSlowMotion)



states[S_INFERNOCOP_BURNINGSPIRITOFJUSTICE] = {SPR_ICOP, A|FF_ANIMATE|FF_FULLBRIGHT, -1, nil, 28, 3, S_NULL}
