local SCREAMSOUNDS = 11

//saved settings
local SKIPINTRO = true
//0 off, 1 per zone, 2 per act
local INTROSETTING = 1
local OUTROSETTING = 1

local DOMIDGAMELOAD = false

//intro junk
local PLAYINTRO = false
local INTROFRAME = -1
local INTROFRAMES = 178
local SWITCHTIME
local LASTMAP = titlemap
local LASTMAPTITLE = ""
local INTROPLAYING = 0

//intermission values
local CURRENTSKIN = "sonic"
local INTERMISSIONTIMER = 0
local displayCriminals = 0
local displayPercent = 0

local CRIMINALSDETAINED = 0
local CRIMINALCOUNT = 0

local STARTCOUNT = 0
local SPCOUNT = 0
local SPDETAIN = 0
local OLDCHECKPOINT = -1


local function CrimeRecords(mo)
	if not (mo.valid)
	or not (mo.flags & MF_ENEMY) then return end
	CRIMINALCOUNT = $1+1
end
addHook("MobjSpawn", CrimeRecords)


local function SaveSettings(player)
	if not (player == consoleplayer) then return end
	//write & update, clears the file before writing

	local file = io.openlocal("client/InfernoCopSettings.dat", "w+")

	local saveVars = {playintro = INTROSETTING,
	outro = OUTROSETTING
	}

	for name, var in pairs(saveVars) do
		file:write(name.." "..var.."\n")
	end

	io.close(file)
end


//
//
// CREDITS CUTSCENE
//
//

//lamp oil, bombs, rope, you want it? it's yours my friend, as long as you've got enough rupees
freeslot("sfx_icinst")

local CREDITSTART
local DELAYCOUNT = 0
local CURRENTSUB
local exitFinalBoss

//brak defeated, let's make sure it's *our* brak
local function TriggerCredits(mo, inf, src, dmg)
	if (multiplayer) then return end

	if not (CURRENTSKIN == "infernocop")
	and not (CURRENTSKIN == "mechacop")
	and not (CURRENTSKIN == "overjustice") then return end

	//check map title and if next map is credits
	if not ((mo.health - dmg) < 1)
	or not (mapheaderinfo[gamemap].lvlttl == "Black Core")
	or not (mapheaderinfo[gamemap].nextlevel == 1103) then
		return
	end
	
	CREDITSTART = leveltime+1
	mo.health = 1000
	mo.state = S_INVISIBLE
	S_StopSound(mo)
	mo.flags = $1|MF_NOCLIP
	return true
end
addHook("MobjDamage", TriggerCredits, MT_CYBRAKDEMON)

//despawn lightning just in case
local function AfraidOfLightning(mo)
	if (multiplayer) then return end
	if (CREDITSTART) then
		P_RemoveMobj(mo)
		return
	end
end
addHook("MobjThinker", AfraidOfLightning, MT_CYBRAKDEMON_ELECTRIC_BARRIER)

local TICSPERFRAME = 3

local function PlayEnding(v, player)

	if (multiplayer) then return end

	if (exitFinalBoss) then
		local frame = v.cachePatch("ICED642")
		//get base screenwidth & height
		local screenWA, screenWB = v.dupx()
		local screenHA, screenHB = v.dupy()

		local SCREENWIDTH = (((screenWB*320)/screenWA)/FRACUNIT)
		local SCREENHEIGHT = (((screenHB*200)/screenHA)/FRACUNIT)

		local patchScale = 2*FRACUNIT

		v.drawScaled((SCREENWIDTH*FRACUNIT/2)-((frame.width*patchScale)/2), (SCREENHEIGHT*FRACUNIT/2)-((frame.height*patchScale)/2), patchScale, frame, V_SNAPTOLEFT|V_PERPLAYER|V_SNAPTOTOP)
		return
	end

	if not (CREDITSTART) then return end
	
	if (CREDITSTART)
	and (CREDITSTART == leveltime) then
		S_ChangeMusic("VSBRAK", true, player, 0)
	end

	local frameNum = (leveltime-CREDITSTART) / TICSPERFRAME
	local fullFrame = leveltime-CREDITSTART
	
	if (frameNum < 1) then
		frameNum = 1
	end
	
	local subs = {}
	
	subs[10] = "THAT SETTLES THIS"
	subs[30] = "\133NOT SO FAST, INFERNO COP"
	subs[46] = "WHAT!?"
	subs[62] = "\133YOU WERE TOO LATE!"
	subs[86] = "" 
	
	subs[131] = "I HAVE NO CHOICE, I'LL HAVE TO USE MY GUN"
	subs[161] = ""
	subs[173] = "IMPOSSIBLE!!"
	subs[203] = "\133[LAUGHTER]"
	
	subs[251] = "GH!"
	
	subs[266] = "\133THANKS TO THE POWER OF THE TRUE BLACK ROCK\nI HAVE BEEN REBORN INTO \130TRUE BRAK EGGMAN"
	subs[273] = "\133THE TRUE BLACK ROCK IS THE ORIGINAL BLACK ROCK SHRUNK DOWN\nA ROCK OF PURE POWER IN A COMPRESSED STATE"
	subs[275] = "\133WITH YOU SO BUSY ARRESTING BLACK ROCK ITSELF\nYOU NEVER REALISED THAT IT WAS A MERE COPY"
	subs[277] = "\133A FAKE BLACK ROCK OF MY OWN CREATION TO FOOL\nYOU INTO WASTING YOUR TIME"
	subs[279] = "\133DON'T YOU FEEL SUCH A FOOL FOR FALLING FOR SUCH\nA GENIUS PLAN?"
	subs[281] = "\133WIELDING THIS ULTIMATE POWER THAT HAS NEVER BEEN SEEN BEFORE,\nTHIS IS THE END FOR YOU, INFERNO COP!"
	subs[289] = ""
	
	
	//alt dialog for true end/all emeralds
	if (All7Emeralds(emeralds)) then
		subs[61] = "\133WITH THE BLACK ROCK'S POWER\nI'M ABLE TO FIGHT ANEW"
		subs[314] = "\133I-IMPOSSIBLE, YOU MANAGED TO COLLECT ALL\nSEVEN OF THE CHAOS EMERALDS AND ATTAIN\nTHE FORM OF GLITTER INFERNO COP!?"
		//subs[328] = "\133ONLY ALL SEVEN OF THE CHAOS EMERALDS BROUGHT TOGETHER CAN STOP\nTHE POWER OF THE BLACK ROCK,\nYOU'LL PERISH FOR THIS!"
	else
		subs[61] = "\133WITH THE COMBINED POWER OF THE BLACK ROCK\nAND THE CHAOS EMERALDS,\nI'M ABLE TO FIGHT ANEW"
		subs[314] = "\133G-GLITTER INFERNO COP!?\nBUT YOU DON'T HAVE ALL SEVEN EMERALDS,\nIMPOSSIBLE!"
		//subs[328] = "\133NO MATTER! WITHOUT ALL SEVEN\nYOU'LL BE TOO WEAK TO DEFEAT MY DEFENSES!"
	end
	subs[304] = "..."
	
	subs[334] = "\133GAH!"
	
	subs[339] = ""
	
	subs[368] = "\133YOU IDIOT, MY BLACK ROCK ARMOR SHRUGS\nOFF YOUR PATHETIC GLITTER BULLETS,\nYOUR GUN IS USELESS!" 
	subs[378] = "\133IT'S FOOLISH FOR Y- OW- OW! STOP!"
	subs[392] = ""
	
	subs[489] = "\133THIS ISN'T THE END OF ME, THANKS TO THE\nBLACK ROCK I HAVE A WEALTH OF ENERGY,\nYOU DON'T HAVE THE HOPES OF B-"
	subs[515] = "\133[SCREAMING]"
	
	subs[404] = "SCREW THIS"
	subs[424] = ""
	
	subs[539] = ""
	
	subs[557] = "HE WAS A GOOD MAN"
	subs[573] = ""
	subs[600] = "WELL, BACK TO HELL"
	subs[630] = ""
	
	//bad end "YOU MISSED" and knocks down to earth
	
	if (subs[frameNum]) then
		CURRENTSUB = subs[frameNum]
	end
	
	
	local cutSounds = {}
	cutSounds[7] = sfx_befall
	cutSounds[62] = sfx_bejet1
	cutSounds[102] = sfx_s3k9f
	
	cutSounds[163] = sfx_icgun1
	cutSounds[165] = sfx_ghit
	
	cutSounds[166] = sfx_icgun2
	cutSounds[168] = sfx_ghit
	
	cutSounds[169] = sfx_icgun1
	cutSounds[171] = sfx_ghit
	
	cutSounds[203] = sfx_bexpld
	cutSounds[204] = sfx_bewar3
	
	cutSounds[248] = sfx_beeyow
	cutSounds[251] = sfx_s3k5d
	
	
	cutSounds[351] = sfx_icgun1
	cutSounds[354] = sfx_icgun2
	cutSounds[355] = sfx_icgun1
	cutSounds[357] = sfx_icgun2
	
	cutSounds[337] = sfx_icinst
	cutSounds[398] = sfx_icinst
	
	cutSounds[396] = sfx_behurt
	cutSounds[332] = sfx_behurt
	
	//pinball
	cutSounds[339] = sfx_icinst
	cutSounds[340] = sfx_s3k7b
	cutSounds[341] = sfx_icinst
	cutSounds[342] = sfx_s3k7b
	cutSounds[343] = sfx_icinst
	cutSounds[344] = sfx_s3k7b
	
	//bonks
	cutSounds[379] = sfx_bedeen
	cutSounds[388] = sfx_bedeen
	cutSounds[393] = sfx_bedeen
	
	//galick bullet
	//cutSounds[413] = 
	cutSounds[461] = sfx_brakrl
	cutSounds[514] = sfx_bedie2
	cutSounds[515] = sfx_icbom5
	
	if (frameNum >= 413)
	and (frameNum < 461) then
		if not (S_IdPlaying(sfx_beelec)) then
			S_StartSound(nil, sfx_beelec, player)
		end
	end
	
	if (cutSounds[frameNum])
	and not (fullFrame % 3) then
		S_StartSound(nil, cutSounds[frameNum], player)
	end
	
	if (frameNum == 525) then
		S_StopMusic(player)
	end
	
	local delayFrames = {}
	
	//brak emeralds
	delayFrames[61] = TICRATE*2
	
	//glass break
	delayFrames[289] = TICRATE
	
	//emeralds
	delayFrames[309] = 2*TICRATE
	
	//hold the frame for a second
	if (delayFrames[frameNum]) then
		if not (DELAYCOUNT)
		or (DELAYCOUNT < delayFrames[frameNum])
			if (frameNum == 289)
			and not (DELAYCOUNT) then
				S_StartSound(nil, sfx_shattr, player)
				S_StopMusic(player)
			end
			CREDITSTART = $1+1
			DELAYCOUNT = $1+1
		else
			CREDITSTART = (leveltime - TICSPERFRAME - 1 - TICSPERFRAME*frameNum)
			DELAYCOUNT = 0
			
			if (frameNum == 309) then
				S_ChangeMusic("_SUPER", true, player)
			end
		end
	end
	
	//get base screenwidth & height
	local screenWA, screenWB = v.dupx()
	local screenHA, screenHB = v.dupy()

	local SCREENWIDTH = (((screenWB*320)/screenWA)/FRACUNIT)
	local SCREENHEIGHT = (((screenHB*200)/screenHA)/FRACUNIT)

	local patchScale = 2*FRACUNIT
	
	//black out the screen to hide the palette change
	//looks better than cutting back to the game
	if (frameNum > 642) then
		local frame = v.cachePatch("ICED642")
		//trigger level exit
		v.drawScaled((SCREENWIDTH*FRACUNIT/2)-((frame.width*patchScale)/2), (SCREENHEIGHT*FRACUNIT/2)-((frame.height*patchScale)/2), patchScale, frame, V_SNAPTOLEFT|V_PERPLAYER|V_SNAPTOTOP)
		CREDITSTART = nil
		DELAYCOUNT = 0
		CURRENTSUB = ""
		exitFinalBoss = true
		return
	end
	
	local frame = v.cachePatch("ICED\$frameNum\")

	v.drawScaled((SCREENWIDTH*FRACUNIT/2)-((frame.width*patchScale)/2), (SCREENHEIGHT*FRACUNIT/2)-((frame.height*patchScale)/2), patchScale, frame, V_SNAPTOLEFT|V_PERPLAYER|V_SNAPTOTOP)
	
	
	//20 + 40
	local emeraldsPos = {
	{"CHAOS1", 40-11, 76},
	{"CHAOS2", 80-11, 64}
	}
	emeraldsPos[4] = {"CHAOS3", 120-11, 48}
	emeraldsPos[8] = {"CHAOS4", 160-11, 32}
	emeraldsPos[16] = {"CHAOS5", 200-11, 48}
	emeraldsPos[32] = {"CHAOS6", 240-11, 64}
	emeraldsPos[64] = {"CHAOS7", 280-11, 76}
	
	//show off your shiny rock
	if (frameNum == 61) then
		
		local roidFrame = leveltime % 35
		
		if (roidFrame < 10) then
			roidFrame = "ROID000\$roidFrame\"
		else
			roidFrame = "ROID00\$roidFrame\"
		end
		
		roidFrame = v.cachePatch(roidFrame)
		v.draw(160-(roidFrame.width/2), 80, roidFrame, V_SNAPTOLEFT|V_SNAPTOTOP)
		
		for pos, val in pairs(emeraldsPos)
			if (emeralds & pos) then continue end
			v.draw(val[2], val[3], v.cachePatch(val[1]), V_SNAPTOLEFT|V_SNAPTOTOP)
		end
	//transform emeralds
	elseif (frameNum == 309)
		local flameFrame = (leveltime/3) % 30
		
		flameFrame = $1+1
		
		if (flameFrame < 27) then
			flameFrame = string.char(string.byte("A")+($1-1))
		else
			flameFrame = $1-27
		end
		
		flameFrame = v.cachePatch("ICOP\$flameFrame\L\$flameFrame\R")
		v.draw(160-(flameFrame.width/2)+40, 200, flameFrame, V_SNAPTOLEFT|V_SNAPTOTOP)
		
		for pos, val in pairs(emeraldsPos)
			if not (emeralds & pos) then continue end
			v.draw(val[2], val[3], v.cachePatch(val[1]), V_SNAPTOLEFT|V_SNAPTOTOP)
		end
	end
	
	if (CURRENTSUB) then
		v.drawString(6, 160, CURRENTSUB, V_SNAPTOLEFT|V_SNAPTOTOP)
	end
	
	if not (CURRENTSKIN == "infernocop")
	and (frameNum < TICRATE*2) then
		local stringLength = v.stringWidth("ONLY INFERNO COP HAS A CUTSCENE, SORRY!")
		v.drawString(320-stringLength - ((320-stringLength)/2), 6, "\134ONLY INFERNO COP HAS A CUTSCENE, SORRY!", V_SNAPTOLEFT|V_SNAPTOTOP)
	end
end

hud.add(PlayEnding)

//
//
//
//
//

local function KilledByJUSTICE(mo, inf, src)
	if not (mo.valid)
	or not (src) then return end
	
	if (src.valid)
		if (src.skin == "infernocop")
		or (src.skin == "mechacop") then
			S_StopSound(mo)
			local boom = P_SpawnMobj(mo.x, mo.y, mo.z, MT_INFERNOCOP_EXPLOSIONOFJUSTICE)
			boom.fuse = 3*TICRATE
			
			boom.state = S_INFERNOCOP_EXPLOSIONOFJUSTICE2+P_RandomRange(0,2)
			
			//MAKE RINGS LESS LOUD AAA
			if (mo.type == MT_RING) then
				boom.state = S_INFERNOCOP_EXPLOSIONOFJUSTICESMALL
				S_StartSound(boom, sfx_icboms)
			else
				S_StartSound(boom, sfx_icbom1+P_RandomRange(0,5))
			end
			
			if not (mo.flags & MF_BOSS) then
				mo.flags2 = $1|MF2_DONTDRAW
			end
	
			if (mo.flags & MF_ENEMY) then
				if (src.player)
				and (src.player == consoleplayer) then
					CRIMINALSDETAINED = $1+1
				end
				S_StartSound(boom, sfx_icyl1+P_RandomRange(4, SCREAMSOUNDS-1))
			end
			
			return
		end
	end
end

addHook("MobjDeath", KilledByJUSTICE)


local function SetIntro(player, var, doHelp)

	local introSettings = {
	"0 - Intro Off",
	"1 - Intro Per Zone",
	"2 - Intro Per Act"
	}

	if not (var)
	or not (tonumber(var))
	and not (tonumber(var) == 0)
	or (tonumber(var) > 2)
	or (tonumber(var) < 0) then
		if (player)
			CONS_Printf(player, "icintro: Change when the intro for Inferno Cop characters plays. Set to \$INTROSETTING\")
			
			for _,text in ipairs(introSettings) do
				CONS_Printf(player, text)
			end
		end
		
		return
	end
	
	INTROSETTING = tonumber(var)
	
	if not (doHelp)
	and (player) then
		CONS_Printf(player, "Inferno Cop characters intro set to "+introSettings[INTROSETTING+1])
		SaveSettings(player)
	end
end
COM_AddCommand("icintro", SetIntro)

local function SetOutro(player, var, doHelp)

	local outroSettings = {
	"0 - Outro Off",
	"1 - Outro On"
	}

	if not (var)
	or not (tonumber(var))
	and not (tonumber(var) == 0)
	or (tonumber(var) > 1)
	or (tonumber(var) < 0) then
		if (player)
			CONS_Printf(player, "outintro: Turn the outro for Inferno Cop characters on or off. Set to \$OUTROSETTING\.")
			
			for _,text in ipairs(outroSettings) do
				CONS_Printf(player, text)
			end
		end
		return
	end
	
	OUTROSETTING = tonumber(var)
	
	if not (doHelp)
	and (player) then
		CONS_Printf(player, "Inferno Cop characters outro set to "+outroSettings[OUTROSETTING+1])
		SaveSettings(player)
		
		if (tonumber(var))
		and (player == consoleplayer) then
			hud.enable("intermissiontally")
			hud.enable("intermissionmessages")
		end
	end
end
COM_AddCommand("icoutro", SetOutro)

local function LoadSettings(player)

	//if not (player == consoleplayer) then return end
	if (consoleplayer)
	and not (consoleplayer == player) then
		return
	end
	
	local file = io.openlocal("client/InfernoCopSettings.dat", "r")

	if not (file) then
		return false
	end

	local commands = {
	playintro = SetIntro,
	outro = SetOutro
	}
	
	for line in file:lines() do

		local nameEnd = string.find(line, " ")

		//invalid command
		if not (nameEnd) then continue end

		local varName = string.sub(line, 0, nameEnd-1)
		//everything after it is the value
		local varVal = string.sub(line, nameEnd+1)

		if not (commands[varName]) then continue end
		commands[varName](player, varVal, true)
	end
	io.close(file)
end

//load settings once added
if not (multiplayer)
and not (consoleplayer) then
	LoadSettings()
else
	//midgame, load using player so it doesn't overwrite settings
	DOMIDGAMELOAD = true
end

local function StartIntro(mapnum)
	//reset credits vars
	CREDITSTART = nil
	DELAYCOUNT = 0
	CURRENTSUB = nil
	exitFinalBoss = false
	//
	
	INTERMISSIONTIMER = 0
	
	displayCriminals = 0
	displayPercent = 0
	
	if not (mapnum == LASTMAP) then
		STARTCOUNT = CRIMINALCOUNT
	end
	
	//store arrest stats on checkpoints in singleplayer
	if not (multiplayer) then
		//remove godmode from cutscene
		if (consoleplayer) then
			consoleplayer.pflags = $1 & ~PF_GODMODE
		end
		
		if (consoleplayer)
		and not (consoleplayer.starpostnum) then
			OLDCHECKPOINT = -1
			CRIMINALCOUNT = STARTCOUNT
			CRIMINALSDETAINED = 0
		else
			CRIMINALSDETAINED = SPDETAIN
			CRIMINALCOUNT = SPCOUNT
		end
	end
	
	//update last map's name to check if it's the same zone
	local OLDTITLE = LASTMAPTITLE
	LASTMAPTITLE = mapheaderinfo[mapnum].lvlttl
	
	//only show the intro once per episode!!!
	if not (INTROSETTING == 2) //always play on 2
		if (mapnum == LASTMAP) //same map loaded
		or not (INTROSETTING) //intro disabled
		or (INTROSETTING == 1) //same zone, don't play
		and (OLDTITLE == LASTMAPTITLE) then
			LASTMAP = mapnum
			PLAYINTRO = false
			SWITCHTIME = nil
			INTROFRAME = -1
			INTROPLAYING = 0
			return
		end
	end
	
	//reset badniks defeated & badnik count
	CRIMINALSDETAINED = 0
	displayCriminals = 0
	
	LASTMAP = mapnum

	if not (CURRENTSKIN == "infernocop")
	and not (CURRENTSKIN == "mechacop") then return end
	
	//if true then return end
	SWITCHTIME = nil
	INTROPLAYING = 1
	//P_PlayJingleMusic(consoleplayer, "POLIZEI", 0, true, JT_OTHER)
	if (consoleplayer)
		P_PlayJingleMusic(consoleplayer, "ICINTRO", 0, false, JT_1UP)
		consoleplayer.powers[pw_extralife] = 4*TICRATE+(TICRATE/2)
	end
	PLAYINTRO = true
	INTROFRAME = leveltime
end

addHook("MapLoad", StartIntro)


local function MapChanging()
	CRIMINALCOUNT = 0
end

addHook("MapChange", MapChanging)

local function PlayScene(v, player, ticker, endtime)
	hud.enable("intermissiontally")
	hud.enable("intermissionmessages")
	
	if not (CURRENTSKIN == "infernocop")
	and not (CURRENTSKIN == "mechacop") then return end
	
	if (ticker <= 1)
		if not (SKIPINTRO) then
		end
	end
	
	if (INTROFRAME < 0) then return end
	
	//use the ticker at first since it'll let us start playing immediately
	if (ticker == endtime)
	and not (SWITCHTIME) then
		SWITCHTIME = leveltime
	end
	
	local frameNum = ticker
	
	//change to leveltime once the ticker runs out
	if (SWITCHTIME) then
		frameNum = ticker+leveltime+1-SWITCHTIME
	end
	
	//black out the screen to hide the palette change
	//looks better than cutting back to the game
	if (frameNum > 178) then
		INTROPLAYING = 2
		return
	end
	
	local frame = v.cachePatch("ICIN\$frameNum\")
	
	v.draw(0, 0, frame, V_SNAPTOLEFT|V_PERPLAYER|V_SNAPTOTOP)
end

hud.add(PlayScene, "titlecard")


///INTERMISSION

local function UpdateValues()
	
	//update killcounts for checkpoints in SP
	if not (multiplayer) then
		if (exitFinalBoss) then
			G_ExitLevel()
			return
		end
		
		if (consoleplayer)
			if (consoleplayer.cmd.buttons & BT_CUSTOM3) then
				consoleplayer.pflags = PF_GODMODE|PF_FULLSTASIS
			end
		
			if (CREDITSTART)
				consoleplayer.pflags = PF_GODMODE|PF_FULLSTASIS
			end
		
			if (consoleplayer.starpostnum > OLDCHECKPOINT)  then
				OLDCHECKPOINT = consoleplayer.starpostnum
				SPDETAIN = CRIMINALSDETAINED
				SPCOUNT	= CRIMINALCOUNT
			end
		end
	end
	
	if (consoleplayer)
		if (DOMIDGAMELOAD) then
			LoadSettings(consoleplayer)
		end
	
		if (consoleplayer.mo) then
			CURRENTSKIN = consoleplayer.mo.skin
		end
	end
	
end
addHook("ThinkFrame", UpdateValues)


local function IntermissionOFJUSTICE()

	if not (OUTROSETTING) then return end

	INTERMISSIONTIMER = $1+1

	if not (CURRENTSKIN == "infernocop")
	and not (CURRENTSKIN == "mechacop")
	and not (CURRENTSKIN == "overjustice")
	or not (CRIMINALCOUNT) then return end
	
	if (INTERMISSIONTIMER < TICRATE) then return end
	
	local showPercent = ((INTERMISSIONTIMER-TICRATE) * 100) / (2*TICRATE)
	
	//delay the percent reveal a little
	if (showPercent >= 115)
	and not (displayPercent)
	and ((CRIMINALSDETAINED * 100) / CRIMINALCOUNT) then
		S_StartSound(nil, sfx_icboms, consoleplayer)
		displayPercent = (CRIMINALSDETAINED * 100) / CRIMINALCOUNT
	end
	
	if (showPercent > 100) then
		showPercent = 100
	end
	
	if not (INTERMISSIONTIMER % 5)
		if (showPercent < 100) then
			local oldDisplay = displayCriminals
			displayCriminals = (CRIMINALSDETAINED) * showPercent
			displayCriminals = $1/100
			
			if not (oldDisplay == displayCriminals) then
				S_StartSound(nil, sfx_icboms, consoleplayer)
			end
		else
			if not (displayCriminals == CRIMINALSDETAINED) then
				S_StartSound(nil, sfx_icboms, consoleplayer)
			end
			displayCriminals = CRIMINALSDETAINED
		end
	end
end
addHook("IntermissionThinker", IntermissionOFJUSTICE)


//returns the level title based on the title card
local function GetLevelTitle()
	local levelName = string.upper(mapheaderinfo[gamemap].lvlttl)
	
	if not (mapheaderinfo[gamemap].levelflags & LF_NOZONE) then
		levelName = $1.." ZONE"
	end
	
	if (mapheaderinfo[gamemap].actnum) then
		levelName = $1.." ACT "..mapheaderinfo[gamemap].actnum
	end
	
	return levelName
end




local function CreateFont(v)
	local font = {}
	//freeslot the capital letters
	for i = 65, 65+25, 1 do
		local letterPatch = string.char(i)
		font[i] = v.cachePatch("ICIT\$letterPatch\")
	end
	
	//numbers and symbols
	local extraSymbols = {
		"%", "&", "-", ".", "!", "?", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0"
	}

	for _,letterPatch in ipairs(extraSymbols) do
		local letterPatch = string.byte(letterPatch)
		font[letterPatch] = v.cachePatch("ICIT\$letterPatch\")
	end
	
	return font
end


local function FitStringToWidth(text, font, maxLen, scale)

	local currentWidth = 0
	local finalText = {{}}
	local textPos = 1
	local currentRow = 1
	
	local lastSpace = 0
	
	for pos,val in ipairs(text) do
		local letterWidth = 15
	
		if (font[val]) then
			letterWidth = font[val].width
		else
			lastSpace = pos
		end
	
		//too wide, make a new row
		if ((currentWidth + letterWidth)*scale > maxLen*FRACUNIT) then
			currentWidth = 0
			currentRow = $1 + 1
			finalText[currentRow] = {}
			
			//if the last letter was a space, just skip it
			if not (val == 32) then
			
				local shortRow = finalText[currentRow-1]
				//transfer last word to new line
				for i = lastSpace+1, table.maxn(finalText[currentRow-1]) do
					table.insert(finalText[currentRow], shortRow[lastSpace+1])
					table.remove(shortRow, lastSpace+1)
				end
				
				finalText[currentRow-1] = shortRow
			else
				continue
			end
		end
		
		table.insert(finalText[currentRow], val)
		currentWidth = $1 + letterWidth
	end
	

	return finalText
end

local function DrawCustomString(v, str, mainXOffset, mainYOffset, infernoLetters)

	local textScale = 4*(FRACUNIT/7)
	
	//get base screenwidth & height
	local screenWA, screenWB = v.dupx()
	local screenHA, screenHB = v.dupy()

	local SCREENWIDTH = (((screenWB*320)/screenWA)/FRACUNIT)
	local SCREENHEIGHT = (((screenHB*200)/screenHA)/FRACUNIT)
	
	str = string.upper(str)
	
	local hudText = {}
	
	local tMod = 0
	for i = 1, string.len(str) do
		local curChar = string.sub(str, i, i)
		
		hudText[i-tMod] = string.byte(curChar)
	end


	local totalWidth = 0
	//get width of current line
	for _,val in ipairs(hudText) do
		if (infernoLetters[val]) then
			totalWidth = $1 + infernoLetters[val].width
		else
			totalWidth = $1 + 15
		end
	end

	hudText = FitStringToWidth(hudText, infernoLetters, 320-32, textScale)

	//BIG LETTERS
	local xOffset = 0
	local yOffset = 0
	for row,rowT in ipairs(hudText) do
		local currentWidth = 0
		
		for pos, val in ipairs(rowT) do
			
			if (val == 32) then 
				currentWidth = $1+15
				continue
			end
			
			
			local CHARWIDTH = infernoLetters[val].width
			local CHARHEIGHT = infernoLetters[val].height
			currentWidth = $1 + CHARWIDTH

			
			//get letter's offset based on the position in the word
			xOffset = (currentWidth - CHARWIDTH) * textScale
			yOffset = (44*row) * textScale

			
			xOffset = $1 + (mainXOffset * FRACUNIT)
			yOffset = $1 + (mainYOffset * FRACUNIT)
			
			v.drawScaled(xOffset, yOffset, textScale, infernoLetters[val], V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
		end
	end
	
	return totalWidth
end



local function DisplayJustice(v)
	
	if not (CURRENTSKIN == "infernocop")
	and not (CURRENTSKIN == "mechacop")
	and not (CURRENTSKIN == "overjustice") then return end
	
	if not (OUTROSETTING) then return end
	
	hud.disable("intermissiontally")
	hud.disable("intermissionmessages")
	
	if (INTERMISSIONTIMER == 1) then
		S_ChangeMusic("ICCLEAR", false, consoleplayer)
	end
	
	
	//get base screenwidth & height
	local screenWA, screenWB = v.dupx()
	local screenHA, screenHB = v.dupy()

	local SCREENWIDTH = (((screenWB*320)/screenWA)/FRACUNIT)
	local SCREENHEIGHT = (((screenHB*200)/screenHA)/FRACUNIT)
	
	local infernoFont = CreateFont(v)
	
	v.drawFill(-80, -80, SCREENWIDTH+160, SCREENHEIGHT+160, 31)

	//background elements
	
	local flameNum = 1 + ((INTERMISSIONTIMER/4) % 18)
	local flame = v.cachePatch("ICFLAM\$flameNum\")
	
	v.draw(0, 0, flame, V_SNAPTOLEFT|V_PERPLAYER|V_SNAPTOTOP)
	
	local badge = v.cachePatch("ICPDBADG")
	v.draw(0, 0, badge, V_SNAPTOLEFT|V_PERPLAYER|V_SNAPTOTOP)
	
	
	//INFERNO COP HAS PASSED ACT 1
	
	local namePatches = {}
	namePatches["infernocop"] = "ICNAME"
	namePatches["mechacop"] = "ICNAME2"
	namePatches["overjustice"] = "ICNAME3"
	
	
	local namePic = v.cachePatch(namePatches[CURRENTSKIN])
	
	v.draw(16, 16, namePic, V_SNAPTOLEFT|V_PERPLAYER|V_SNAPTOTOP)
	
	
	local levelFullName = GetLevelTitle()
	
	DrawCustomString(v, "HAS ARRESTED "+levelFullName, 16, 48, infernoFont)
	
	//displays
	
	local levelIcon = v.cachePatch(G_BuildMapName(gamemap).."P")
	
	v.drawScaled((240-4)*FRACUNIT, (4)*FRACUNIT, FRACUNIT/2, levelIcon, V_SNAPTOLEFT|V_PERPLAYER|V_SNAPTOTOP)
	
	
	local jailBars = v.cachePatch("STAGEJAIL")
	v.draw(240-4, 4, jailBars, V_SNAPTOLEFT|V_PERPLAYER|V_SNAPTOTOP)
	
	
	
	if (CRIMINALCOUNT) then
		local detainGap = DrawCustomString(v, "CRIMINALS DETAINED "+displayCriminals, 16, 160-44-4, infernoFont)

		DrawCustomString(v, tostring(displayCriminals), detainGap, 160-44, infernoFont)
	
		DrawCustomString(v, "CRIME RATE PERSONALLY LOWERED BY \$displayPercent\%", 16, 184-44-4, infernoFont)
	else
		DrawCustomString(v, "GOOD JOB!", 16, 180-44, infernoFont)
	end
end

hud.add(DisplayJustice, "intermission")
